
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;

import javax.swing.AbstractButton;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JSlider;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


@SuppressWarnings("serial")
public class RandomGame extends JFrame implements ActionListener {
		private JLabel label = new JLabel("ein Text");
		private JSlider slider = new JSlider(0,20,0);
		private JButton button = new JButton("raten");
		
		private  int zufalls_zahl = random_number();
		
		public RandomGame(){
			super("GridLayout");
			setLayout(new GridLayout(3,0));
			
			add(label);
			add(slider);
			add(button);

			JMenuBar menuBar = new JMenuBar();
			JMenu menu = new JMenu("Spiel");
			//menu.add(machItem("newGame"));
			menu.add(machItem("Beenden"));
			menuBar.add(menu);
			
			menu = new JMenu("Einstellung");
			JMenu menu2 = new JMenu("Schwierigkeit");
			menu2.add(machItem("leicht"));
			menu2.add(machItem("mitte"));
			menu2.add(machItem("schwer"));
			menu.add(menu2);
			menuBar.add(menu);
			
			setJMenuBar(menuBar);
			
			//Slider
			slider.addChangeListener(new SliderListener(this));
			//Button
			button.addActionListener(new ButtonListener(this));
			
			
			setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			setLocation(800, 100);
			setVisible(true);
			pack();
		}
		public int getZufallsZahl(){
			return zufalls_zahl;
		}
		public void setZufallsZahl(int z){
			zufalls_zahl=z;
		}	

		public JSlider getSlider(){
			return slider;
		}
		
		public void setSlider(JSlider s){
			slider = s;
		}
		
		public JLabel getLabel(){
			return label;
		}
		
		public void setJLabel(JLabel l){
			label = l;
		}
		
		private JMenuItem machItem(String text){
			JMenuItem menuItem = new JMenuItem(text);
			menuItem.addActionListener(this);
			return menuItem;
		}


		@Override
		public void actionPerformed(ActionEvent e) {
			String a= ((AbstractButton) e.getSource()).getText();
			if(a.equals("Beenden")){
				System.exit(0);
			}
			
			if(a.equals("schwer")){
					slider.setMaximum(40);
					zufalls_zahl=random_number();
					System.out.println(zufalls_zahl);
					
			}				
			if(a.equals("mittel")){
				slider.setMaximum(20);
				zufalls_zahl=random_number();
				System.out.println(zufalls_zahl);
			}
				
			if(a.equals("leicht")){
				slider.setMaximum(5);
				zufalls_zahl=random_number(); 
				System.out.println(zufalls_zahl);
			}	
		}
	
		
		//Random
		int random_number(){
			return new Random().nextInt(slider.getMaximum());
			
		}

		public static void main(String[] args) {
			new RandomGame();
		}
	}

class SliderListener implements ChangeListener{
	private RandomGame r;
	
	SliderListener(RandomGame random){
		r = random;
	}	
	
	
	@Override
	public void stateChanged(ChangeEvent e) {
		  r.getLabel().setText("" + r.getSlider().getValue());
	}
}

class ButtonListener implements ActionListener {

	private RandomGame r;
	
	ButtonListener(RandomGame random){
		r = random;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		int z = r.getZufallsZahl();
		System.out.println(z);
		if( r.getSlider().getValue()== z){
			System.out.println(r);
			r.getLabel().setText("RICHTIG!");
			r.setZufallsZahl(r.random_number());
			
		}
	}
}
